"""
    EMIL DiscountService

    The EMIL DiscountService API description  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@emil.de
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from eis.discount.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from eis.discount.exceptions import ApiAttributeError



class PolicyVoucherTransactionClass(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('old_status',): {
            'REDEEMABLE': "REDEEMABLE",
            'ACTIVE': "ACTIVE",
            'USED': "USED",
        },
        ('new_status',): {
            'REDEEMABLE': "REDEEMABLE",
            'ACTIVE': "ACTIVE",
            'USED': "USED",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'id': (float,),  # noqa: E501
            'code': (str,),  # noqa: E501
            'policy_voucher_id': (float,),  # noqa: E501
            'invoice_number': (str,),  # noqa: E501
            'policy_number': (str,),  # noqa: E501
            'amount': (float,),  # noqa: E501
            'months': (float,),  # noqa: E501
            'old_remaining_credits': (float,),  # noqa: E501
            'new_remaining_credits': (float,),  # noqa: E501
            'old_remaining_months': (float,),  # noqa: E501
            'new_remaining_months': (float,),  # noqa: E501
            'old_status': (str,),  # noqa: E501
            'new_status': (str,),  # noqa: E501
            'ern': (str,),  # noqa: E501
            'created_at': (datetime,),  # noqa: E501
            'created_by': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'code': 'code',  # noqa: E501
        'policy_voucher_id': 'policyVoucherId',  # noqa: E501
        'invoice_number': 'invoiceNumber',  # noqa: E501
        'policy_number': 'policyNumber',  # noqa: E501
        'amount': 'amount',  # noqa: E501
        'months': 'months',  # noqa: E501
        'old_remaining_credits': 'oldRemainingCredits',  # noqa: E501
        'new_remaining_credits': 'newRemainingCredits',  # noqa: E501
        'old_remaining_months': 'oldRemainingMonths',  # noqa: E501
        'new_remaining_months': 'newRemainingMonths',  # noqa: E501
        'old_status': 'oldStatus',  # noqa: E501
        'new_status': 'newStatus',  # noqa: E501
        'ern': 'ern',  # noqa: E501
        'created_at': 'createdAt',  # noqa: E501
        'created_by': 'createdBy',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, code, policy_voucher_id, invoice_number, policy_number, amount, months, old_remaining_credits, new_remaining_credits, old_remaining_months, new_remaining_months, old_status, new_status, ern, created_at, created_by, *args, **kwargs):  # noqa: E501
        """PolicyVoucherTransactionClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            policy_voucher_id (float): Policy voucher id
            invoice_number (str): Invoice number
            policy_number (str): Policy number
            amount (float): The transaction amount (in cents!) the voucher credits were descreased by
            months (float): The number of months the voucher months were descreased by
            old_remaining_credits (float): The amount (in cents!) of remaining voucher credits BEFORE the transaction
            new_remaining_credits (float): The amount (in cents!) of remaining voucher credits AFTER the transaction
            old_remaining_months (float): The number of remaining months to charge the voucher BEFORE the transaction
            new_remaining_months (float): The number of remaining months to charge the voucher AFTER the transaction
            old_status (str): Voucher status BEFORE the transaction
            new_status (str): Voucher status AFTER the transaction
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.
            created_at (datetime): Time at which the object was created.
            created_by (str): Identifier of the user who created the record.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.policy_voucher_id = policy_voucher_id
        self.invoice_number = invoice_number
        self.policy_number = policy_number
        self.amount = amount
        self.months = months
        self.old_remaining_credits = old_remaining_credits
        self.new_remaining_credits = new_remaining_credits
        self.old_remaining_months = old_remaining_months
        self.new_remaining_months = new_remaining_months
        self.old_status = old_status
        self.new_status = new_status
        self.ern = ern
        self.created_at = created_at
        self.created_by = created_by
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, id, code, policy_voucher_id, invoice_number, policy_number, amount, months, old_remaining_credits, new_remaining_credits, old_remaining_months, new_remaining_months, old_status, new_status, ern, created_at, created_by, *args, **kwargs):  # noqa: E501
        """PolicyVoucherTransactionClass - a model defined in OpenAPI

        Args:
            id (float): Internal unique identifier for the object. You should not have to use this, use code instead.
            code (str): Unique identifier for the object.
            policy_voucher_id (float): Policy voucher id
            invoice_number (str): Invoice number
            policy_number (str): Policy number
            amount (float): The transaction amount (in cents!) the voucher credits were descreased by
            months (float): The number of months the voucher months were descreased by
            old_remaining_credits (float): The amount (in cents!) of remaining voucher credits BEFORE the transaction
            new_remaining_credits (float): The amount (in cents!) of remaining voucher credits AFTER the transaction
            old_remaining_months (float): The number of remaining months to charge the voucher BEFORE the transaction
            new_remaining_months (float): The number of remaining months to charge the voucher AFTER the transaction
            old_status (str): Voucher status BEFORE the transaction
            new_status (str): Voucher status AFTER the transaction
            ern (str): Emil Resources Names (ERN) identifies the most specific owner of a resource.
            created_at (datetime): Time at which the object was created.
            created_by (str): Identifier of the user who created the record.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.code = code
        self.policy_voucher_id = policy_voucher_id
        self.invoice_number = invoice_number
        self.policy_number = policy_number
        self.amount = amount
        self.months = months
        self.old_remaining_credits = old_remaining_credits
        self.new_remaining_credits = new_remaining_credits
        self.old_remaining_months = old_remaining_months
        self.new_remaining_months = new_remaining_months
        self.old_status = old_status
        self.new_status = new_status
        self.ern = ern
        self.created_at = created_at
        self.created_by = created_by
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
